<template>
  <div class="content">
    <PageTitle>Routes</PageTitle>
    <div class="col-12 drop-shadow border-radius p-4">
      <SearchField class="mb-4" v-model="searchQuery"></SearchField>
      <GridComponent
        :data="data"
        :columns="columns"
        :filterKey="searchQuery"
      ></GridComponent>
    </div>
  </div>
</template>

<script>
import PageTitle from "./atoms/PageTitle.vue";
import GridComponent from "./organisms/GridComponent.vue";
import SearchField from "./atoms/SearchField.vue";
import axios from "axios";
import store from "@/store/auth";

export default {
  components: { PageTitle, GridComponent, SearchField },
  data() {
    return {
      data: [],
      columns: ["route", "stad", "status"],
      searchQuery: "",
    };
  },
  created() {
    this.doRequestsInOrder();
  },
  methods: {
    async doRequestsInOrder() {
      await this.getRoutes();
      await this.getTodaysRoutes();
      await this.getRouteSessionsToday();
    },
    addMockData() {
      this.data = this.data.concat([
        {
          id: 25168,
          student: "Rick Astley",
          route: "Hoog-gent",
          stad: "Gent",
          status: "40%",
          opmerking: 2,
          opmerkingDetail: "",
        },
        {
          id: 25169,
          student: "Rick Astley",
          route: "Laag-gent",
          stad: "Gent",
          status: "54%",
          opmerking: 0,
          opmerkingDetail: "",
        },
        {
          id: 25170,
          student: "Rick Astley",
          route: "'t Zuid",
          stad: "Antwerpen",
          status: "79%",
          opmerking: 0,
          opmerkingDetail: "",
        },
        {
          id: 25171,
          student: "Rick Astley",
          route: "Midden-gent",
          stad: "Gent",
          status: "19%",
          opmerking: 1,
          opmerkingDetail: "",
        },
        {
          id: 25172,
          student: "Rick Astley",
          route: "'t Zuid",
          stad: "Antwerpen",
          status: "10%",
          opmerking: 0,
          opmerkingDetail: "",
        },
      ]);
    },
    async getRoutes() {
      store.commit("general/setLoading", true);
      try {
        await axios.get("/api/round").then((response) => {
          if (response.status === 200) {
            this.setAndRefactor(response.data);
            //this.addMockData();
          }
          store.commit("general/setLoading", false);
        });
      } catch (error) {
        console.log(error);
        store.commit("general/setLoading", false);
      }
    },
    setAndRefactor(routes) {
      this.data = [];
      routes.forEach((route) => {
        this.data.push({
          id: route.id,
          student: null,
          route: route.name,
          stad: route.region.name,
          status: null,
          opmerking: 0,
        });
      });
    },
    async getTodaysRoutes() {
      await axios
        .get("/api/allRounds/today")
        .then((response) => {
          if (response.status === 200) {
            this.data.forEach((route) => {
              route.status = response.data.find((o) => o.id == route.id)
                ? 0
                : null;
            });
          }
        })
        .catch(() => {});
    },
    async getRouteSessionsToday() {
      store.commit("general/setLoading", true);
      try {
        await axios
          .post("/api/sessions", { day: new Date().toISOString() })
          .then((response) => {
            if (response.status === 200) {
              response.data.forEach((session) => {
                var currentRoute = this.data.find(
                  (o) => o.id == session.roundId
                );
                currentRoute.status =
                  session.finishedBuildings / session.totalBuildings;
              });
            }
            store.commit("general/setLoading", false);
          });
      } catch (error) {
        console.log(error);
        store.commit("general/setLoading", false);
      }
    },
  },
};
</script>

<style lang="scss">
.content {
  display: flex;
  flex-direction: column;
}
</style>
